/*****************************************************************************/
/*                                                                           */
/*  (X)NET (c) by Jimy, DL1GJI                                               */
/*                                                                           */
/*      This Source is NOT Public Domain                                     */
/*                                                                           */
/*      C Module                   cgiutil.c                                 */
/*      Version                    1.38                                      */
/*      Last Change                26.09.05 10:40:01                         */
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cgiutil.h"

typedef struct {
	char *var;
	char *val;
} CGI_PARAMS;

static int varcmp(const void *a,const void *b)
{
	const CGI_PARAMS *a1 = a;
	const CGI_PARAMS *b1 = b;

	return strcmp(a1->var,b1->var);
}

char *cgival(char *v)
{
static char *str = NULL;
static int vars;
static CGI_PARAMS	cgiparam[50],*cgip,key;
	int	c;
	char	*s,*t;

	if(!str) {
		str = getenv("QUERY_STRING");
		if(!str){
			fprintf(stderr,"QUERY_STRING missing\n");
			exit(1);
		}
		s = str;
		vars = 0;
		while(*s){
			cgiparam[vars].var = s;
			while(*s != '=') s++;
			*s++ = 0;
			cgiparam[vars].val = t = s;
			while(*s && *s != '&') {
				switch(*s) {
				case '&':
					*t = 0;
					*s++ = 0;
					break;
				case '%':
					s++;
					sscanf(s,"%2x",&c);
					*t++ = c;
					s += 2;
					break;
				case '+':
					*t++ = ' ';
					s++;
					break;
				default:
					*t++ = *s++;	
					break;
				}
			}
			if(*s == '&') *s++ = 0;
/*			printf("Setting '%s' = '%s'\n",cgiparam[vars].var,cgiparam[vars].val);*/
			vars++;
		}
		qsort(cgiparam,vars,sizeof(CGI_PARAMS),varcmp);
	}
	key.var = v;
	cgip = bsearch(&key,cgiparam,vars,sizeof(CGI_PARAMS),varcmp);
/*	printf("'%s' ? -> %s\n",v,cgip ? cgip->val : "?");*/
	if(cgip) return cgip->val;
	return "";
}
