/*****************************************************************************/
/*                                                                           */
/*  (X)NET (c) by Jimy, DL1GJI                                               */
/*                                                                           */
/*      This Source is NOT Public Domain                                     */
/*                                                                           */
/*      C Module                   postat.c                                  */
/*      Version                    1.38                                      */
/*      Last Change                26.09.05 10:40:01                         */
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "gd.h"
#include "gdfontg.h"
#include "gdfonts.h"
// #include "gdfontl.h"
#include "cgiutil.h"
#include "postat.h"

#define XOFFSET	32
#define YOFFSET 32
#define	GRID	16
#define YHEIGHT	320
#define	XWIDTH	(rows * rowlen)
#define XBYTEBASE	(XOFFSET)	/* Byte Statistik */
#define YBYTEBASE	(YHEIGHT + YOFFSET)	/* Byte Statistik */

#define	XSIZE	(XOFFSET * 2 + XWIDTH)
#define YSIZE	(YHEIGHT + 2 * YOFFSET + GRID)

/* Color indexes */
typedef struct {
	int rows;
	int rowlen;
} CFG;

CFG cfg[] = {
	{ 64 , 8 },
	{ 128, 4 },
	{ 256, 2 },
	{ 32 , 16 },
};

int	rows,	rowlen;

int white;
int blue;
int red;
int green;
int black;

long maxbaud,maxstdbaud;
double	scale;
time_t starttime,endtime;
int	dcount;

typedef struct {
	time_t	dt;
	unsigned long baud;
	unsigned long baud_tx;
	unsigned long baud_rx;
	unsigned long repbaud;
	unsigned long repbaud_rx;
	unsigned long repbaud_tx;
	unsigned long okbaud;
	unsigned long okbaud_rx;
	unsigned long okbaud_tx;
} DELTAS;

STATREC	stat[256 + 1];
STATREC portstat[20];
DELTAS	delta[256];

#define	long86(a)	{a = ((a&0xFFL)<<24)|((a&0xFF00L)<<8)|((a&0xFF0000L)>>8)|((a&0xFF000000L)>>24);}
#define	int86(a)	{a = ((a&0xFF)<<8)|((a&0xFF00)>>8);}
#define	ldiff(a,b)	(((unsigned long) (a) - (unsigned long) (b)) & 0x7FFFFFFFL)
char	*time2str(time_t time)
{
static	char timestr[20];
	struct tm *t;

	t = gmtime(&time);
	sprintf(timestr,"%2d.%02d. %2d:%02d",
		t->tm_mday,
		t->tm_mon+1,
		t->tm_hour,
		t->tm_min);
	return timestr;
}

static void byteswap(STATREC *s)
{
	if((s->port & 0x8000u) == 0) {
		long86(s->time);
		long86(s->txb);
		long86(s->tx2b);
		long86(s->tx2rep);
		long86(s->rxb);
		long86(s->rx2rep);
		long86(s->rx2b);
		int86(s->port);
		int86(s->con);
	}
	s->port &= 0xFF;
}

static void addrecs(STATREC *end)
{
	int i;

#define	addfield(a)	end->a += portstat[i].a

	end->txb = 0;
	end->rxb = 0;
	end->tx2rep = 0;
	end->rx2rep = 0;
	end->tx2b = 0;
	end->rx2b = 0;
	end->con = 0;
	for(i=0;i<20;i++){
		addfield(txb);
		addfield(rxb);
		addfield(tx2rep);
		addfield(rx2rep);
		addfield(tx2b);
		addfield(rx2b);
		addfield(con);
	}
}

/* Einlesen der Daten */

static int readstat(gdImagePtr img,int port)
{
	char	filename[80];
	size_t	filesize;
	int	j,k;
	time_t	interval;
	time_t	sample_point;
	FILE *i;
	STATREC *end,buf;

	sprintf(filename,"postat/%s",cgival("df"));
	interval = atol(cgival("interval"));
	interval *= 60; // Umrechnen in Min
	if((i=fopen(filename,"rb")) == NULL) {
		fprintf(stderr,"File %s is missing\n",filename);
		gdImageString(img, gdFontSmall,XOFFSET*2,YOFFSET,"Data file not found.", red);
		return -1;
	}
	j = rows;
	k = 1;
	starttime = 0;
	sample_point = time(NULL) + 3600*24*5;
	end = &stat[rows];
	while(j >= 0
		&& fseek(i,-sizeof(STATREC)*k,SEEK_END) == 0
		&& fread(&buf,sizeof(STATREC),1,i) == 1){
		byteswap(&buf);
		if(buf.time <= sample_point) {
			if(port >= 0) {
				if(port == buf.port) {
					starttime = buf.time;
					*end = buf;
					end--;
					j--;
					sample_point = buf.time - interval;
				}
			} else { /* hier gehts weiter ...*/
				if(end->time != buf.time) {
					if(end->time == 0) {
						/**end = buf;*/
					} else {
						end--;
						j--;
						sample_point = buf.time - interval;
					}
					end->time = buf.time;
				}
				portstat[buf.port] = buf;
				addrecs(end);
				starttime = buf.time;
			}
		}
		k++;
	}
	j++;
	if(j > 0) memset(stat,0,sizeof(STATREC) * j);
	endtime = stat[rows].time;
	fclose(i);
}
/*
 *	Deltas errechnen
 */
static void calc_delt(void)
{
	int i,j;
	double	xb_rx,xb_tx,x2r_rx,x2r_tx,x2b_rx,x2b_tx;
	unsigned long dt;
	STATREC	*n,*npe;
	DELTAS	*d;

	maxbaud = 0;
	dcount = 0;
	for(i = 0;i<rows;i++) {
		n = &stat[i];
		d = &delta[i];
		npe = n+1;
		if(n->time && npe->time) {
			xb_tx = ldiff(npe->txb , n->txb);
			xb_rx = ldiff(npe->rxb,n->rxb);
			x2r_rx = ldiff(npe->rx2rep,n->rx2rep);
			x2r_tx = ldiff(npe->tx2rep,n->tx2rep);
			x2b_rx = ldiff(npe->rx2b,n->rx2b);
			x2b_tx = ldiff(npe->tx2b,n->tx2b);
			dt = npe->time - n->time;
			if(dt && ((xb_rx + xb_tx) * 8)/dt < 2000000L) {

				d->baud_rx = (xb_rx * 8.0)/dt;
				d->baud_tx = (xb_tx * 8.0)/dt;
				d->baud = d->baud_tx + d->baud_rx;

				d->okbaud_rx = (x2b_rx * 8.0) / dt;
				d->okbaud_tx = (x2b_tx * 8.0) / dt;
				d->okbaud = d->okbaud_rx + d->okbaud_tx;

				d->repbaud_rx = (x2r_rx * 8.0) / dt;
				d->repbaud_tx = (x2r_tx * 8.0) / dt;
				d->repbaud = d->repbaud_tx + d->repbaud_rx;

				if(d->baud > maxbaud) maxbaud = d->baud;
				d->dt = n->time;
			}
			dcount++;
		}
	}
}

static long std_baud(long b)
{
	long div,sb;
	
	sb = b;
	div = 1;
	while(sb & 0xFFFFFF80L) {
		sb >>= 1;
		div <<= 1;
	}
/*	fprintf(stderr,"%ld Baud = ",b);*/
	b = (b + (75*div-1)) / (75*div);
/*	fprintf(stderr,"%ld \n",b*div*75);*/
	return b * div * 75;
}

static void draw(gdImagePtr i)
{
	unsigned int	j,yheight,ok,rep;

	maxstdbaud = std_baud(maxbaud);
	if(maxbaud == 0 || maxstdbaud == 0) return;
	scale =	YHEIGHT/((double) maxstdbaud);
	for(j=0;j<rows;j++) {
		yheight = (delta[j].baud * scale) + 0.5;
		if(yheight && yheight <= YHEIGHT) gdImageFilledRectangle(i,XBYTEBASE + j * rowlen,YBYTEBASE - yheight,XBYTEBASE + (j+1) * rowlen -2,YBYTEBASE-1,blue);
		ok = (delta[j].okbaud * scale) + 0.5;		
		rep = ((delta[j].repbaud * scale) + 0.5);
		yheight = rep + ok;
		if(yheight && yheight <= YHEIGHT) gdImageFilledRectangle(i,XBYTEBASE + j * rowlen,YBYTEBASE - yheight,XBYTEBASE + (j+1) * rowlen -2,YBYTEBASE-1,red);
		yheight = ok;
		if(yheight && yheight <= YHEIGHT) gdImageFilledRectangle(i,XBYTEBASE + j * rowlen,YBYTEBASE - yheight,XBYTEBASE + (j+1) * rowlen -2,YBYTEBASE-1,green);
	}
}

static void drawqual_rx(gdImagePtr i)
{
	int	j,yheight,lastx,lasty;
	double	qual,rep,ok;
	int	x,y;

	if(maxbaud == 0) return;
	lastx = 0;
/*	fprintf(stderr,"Drawqual\n");*/
	for(j=0;j<rows;j++) {
		ok = delta[j].okbaud_rx;
		rep = delta[j].repbaud_rx;
		if(rep + ok > 1 && ok > 1) {
			qual = ok / (rep + ok);
			yheight = (YHEIGHT * qual) + 0.5;
			x = XBYTEBASE + j * rowlen + rowlen/2;
			y = YBYTEBASE - yheight;
			if(lastx) {
				gdImageLine(i,lastx,lasty,x,y,green);
			} else {
				gdImageLine(i,x-rowlen/2,y,x,y,green);
			}
			lastx = x;
			lasty = y;
		} else {
			lastx = 0;
		}
	}
}

static void drawqual_tx(gdImagePtr i)
{
	int	j,yheight,lastx,lasty;
	double	qual,rep,ok;
	int	x,y;

	if(maxbaud == 0) return;
	lastx = 0;
/*	fprintf(stderr,"Drawqual\n");*/
	for(j=0;j<rows;j++) {
		ok = delta[j].okbaud_tx;
		rep = delta[j].repbaud_tx;
		if(rep + ok > 1 && ok > 1) {
			qual = ok / (rep + ok);
			yheight = (YHEIGHT * qual) + 0.5;
			x = XBYTEBASE + j * rowlen + rowlen/2;
			y = YBYTEBASE - yheight;
			if(lastx) {
				gdImageLine(i,lastx,lasty,x,y,red);
			} else {
				gdImageLine(i,x-rowlen/2,y,x,y,red);
			}
			lastx = x;
			lasty = y;
		} else {
			lastx = 0;
		}
	}
}

static void drawl2con(gdImagePtr i)
{
	int	j,yheight,lastx,lasty;
	double	qual,rep,ok;
	int	x,y;

	for(j=0;j<rows;j++) {
		yheight = stat[j].con;
		if(yheight > YSIZE) yheight = YSIZE;
		if(yheight) {
			gdImageLine(i,XBYTEBASE + j * rowlen,YBYTEBASE-yheight,XBYTEBASE + (j+1) * rowlen,YBYTEBASE-yheight,blue);
		}
	}
}

static void axes(gdImagePtr i)
{
	int j;
	
	gdImageLine(i,XBYTEBASE,YOFFSET,XBYTEBASE,YBYTEBASE,black);
	gdImageLine(i,XSIZE - XOFFSET,YOFFSET,XSIZE - XOFFSET,YBYTEBASE,black);
	gdImageLine(i,XBYTEBASE,YBYTEBASE,XSIZE - XOFFSET,YBYTEBASE,black);
	for(j=1;j<rows;j++) {
		gdImageLine(i,XBYTEBASE + j * rowlen,YBYTEBASE - 3,XBYTEBASE + j * rowlen,YBYTEBASE + 5,black);	
	}
}
#define LEGY	(YBYTEBASE + GRID + GRID)
static void legtext(gdImagePtr i,int x,char *text,int col,int line)
{
	if(line) {
		gdImageLine(i,XOFFSET + GRID/2 + x,LEGY + GRID/2,XOFFSET + x + GRID,LEGY + GRID/2,col);
	} else {
		gdImageFilledRectangle(i,XOFFSET + x,LEGY,XOFFSET + x + GRID - 1,LEGY + GRID - 1,col);
	}
	gdImageString(i, gdFontSmall,XOFFSET + x + GRID + GRID/2,LEGY,text, black);		
}

static void legend(gdImagePtr i,int user,int port)
{
	int j,yheight,t;
	char str[80],*s;
	char portstr[20];
	char filestr[80];
	long baud;
	
	strcpy(filestr,cgival("df"));
	s = strchr(filestr,'.');
	if(s) *s = 0;
//	strupr(filestr);
	if(port < 0) strcpy(portstr,"All ports"); else sprintf(portstr,"Port [%d]",port);
	s = str;
	s += sprintf(s,"%s %s from %24.24s",portstr,filestr,ctime(&starttime));
	s += sprintf(s," to %24.24s",ctime(&endtime));
	gdImageString(i, gdFontSmall,YOFFSET,0,str, black);
	for(j = 1;j < 16;j++) {
		baud = std_baud(maxstdbaud/j);
		sprintf(str,"%ld",baud);
		yheight = (baud * scale) + 0.5;
		gdImageString(i, gdFontSmall,0,YBYTEBASE-yheight,str, black);	
		gdImageLine(i,XOFFSET-5,YBYTEBASE-yheight,XOFFSET+3,YBYTEBASE-yheight,black);	
	}
	for(j = 25, yheight = YHEIGHT/4; j <= 100;j += 25, yheight += YHEIGHT/4) {
		if (user) {
			sprintf(str,"%3d",yheight);
		} else {
			sprintf(str,"%3d%%",j);
		} 
		gdImageString(i, gdFontSmall,XSIZE - XOFFSET,YBYTEBASE-yheight,str, black);	
		gdImageLine(i,XSIZE - XOFFSET-3,YBYTEBASE-yheight,XSIZE - XOFFSET+5,YBYTEBASE-yheight,black);	
	}
	if(user) {
		legtext(i,0 * XWIDTH/6,"Data",		green,	0);
		legtext(i,1 * XWIDTH/6,"Rej Data",	red,	0);
		legtext(i,2 * XWIDTH/6,"UI and S",	blue,	0);
		legtext(i,3 * XWIDTH/6,"RX Quality",	green,	1);
		legtext(i,4 * XWIDTH/6,"TX Quality",	red,	1);
		legtext(i,5 * XWIDTH/6,"L2 Conn.",	blue,	1);
	} else {
		legtext(i,0 * XWIDTH/5,"Data",		green,	0);
		legtext(i,1 * XWIDTH/5,"Rej Data",	red,	0);
		legtext(i,2 * XWIDTH/5,"UI and S",	blue,	0);
		legtext(i,3 * XWIDTH/5,"RX Quality",	green,	1);
		legtext(i,4 * XWIDTH/5,"TX Quality",	red,	1);
	}
	for(j=0;j < XSIZE; j += XSIZE/6) {
		t = j/rowlen;
		gdImageLine(i,XOFFSET+j,YBYTEBASE,XOFFSET+j,YBYTEBASE+GRID/2,black);	
		if(delta[t].dt) {
			gdImageString(i, gdFontSmall,XOFFSET/2+j,YBYTEBASE+GRID/2,time2str(delta[t].dt), black);
		}
	}
}

int main(void)
{
	/* Input and output files */
	char	*para,*countfile;
	gdImagePtr im_out;
	int	cf,port;
	int	user = 0;

	cf = atoi(cgival("cfg"));
	port = atoi(cgival("port"));
	if(cf >= sizeof(cfg)/sizeof(CFG)) cf = 0;
	rows = cfg[cf].rows;
	rowlen = cfg[cf].rowlen;
	im_out = gdImageCreate(XSIZE, YSIZE);

	/* First color allocated is background. */
	white = gdImageColorAllocate(im_out, 255, 255, 255);
	black = gdImageColorAllocate(im_out, 0, 0, 0);

	/* Set transparent color. */
	gdImageColorTransparent(im_out, white);
	red = gdImageColorAllocate(im_out, 255, 0, 0);
	green = gdImageColorAllocate(im_out, 0, 255, 0);
	blue = gdImageColorAllocate(im_out, 0, 0, 255);
	axes(im_out);
	readstat(im_out,port);
	calc_delt();
	draw(im_out);
	user = *cgival("l2con") == '1';
	if(user) drawl2con(im_out);
	drawqual_rx(im_out);
	drawqual_tx(im_out);
	legend(im_out,user,port);
#ifdef GIF
	printf("Content-type: image/gif\n\n");
	gdImageGif(im_out, stdout);
#else
	printf("Content-type: image/png\n\n");
	gdImagePng(im_out, stdout);
#endif
	gdImageDestroy(im_out);
	return 0;
}

