/*
 *	Die Datei port.sta hat folgendes Record-Format:
 *      Aufgezeichnet werden nur die Ports, bei denen es im Messintervall eine nderung
 *      der TX- oder der RX-Bytes gab.
 */
#define STATPORTS	24

typedef struct {
	time_t	time;		/* Uhrzeit der Messung */
	unsigned short port;    /* Portnummer, Bit 15 ist immer auf 1 gesetzt */
	unsigned short con;     /* Anzahl Connects zum Messzeitpunkt */
	unsigned long txb,	/* Anzahl der bislang gesendeten Bytes */
		      tx2b,     /* "      der korrekt gesendeten Bytes (L2) */
                      tx2rep,   /* "      der wiederholten Bytes (L2) */
                      rxb,	/* "      der empfangenen Bytes */
                      rx2b,     /* "      der im L2 korrekt empfangenen Bytes */
                      rx2rep;   /* "      der unntig wiederholten Bytes */
} STATREC;
